/** @jsxRuntime classic */
/** @jsx jsx */
import { jsx } from '@keystone-ui/core';
import { type Descendant } from 'slate';
import { type CardValueComponent, type CellComponent, type FieldController, type FieldControllerConfig, type FieldProps } from '@keystone-6/core/types';
import { type ComponentBlock } from "./component-blocks.js";
import { type Relationships } from "./DocumentEditor/relationship.js";
export declare const Field: ({ field, value, onChange, autoFocus, forceValidation, }: FieldProps<typeof controller>) => jsx.JSX.Element;
export declare const Cell: CellComponent;
export declare const CardValue: CardValueComponent;
export declare const allowedExportsOnCustomViews: string[];
export type DocumentFeatures = {
    formatting: {
        inlineMarks: {
            bold: boolean;
            italic: boolean;
            underline: boolean;
            strikethrough: boolean;
            code: boolean;
            superscript: boolean;
            subscript: boolean;
            keyboard: boolean;
        };
        listTypes: {
            ordered: boolean;
            unordered: boolean;
        };
        alignment: {
            center: boolean;
            end: boolean;
        };
        headingLevels: (1 | 2 | 3 | 4 | 5 | 6)[];
        blockTypes: {
            blockquote: boolean;
            code: boolean;
        };
        softBreaks: boolean;
    };
    links: boolean;
    dividers: boolean;
    layouts: [number, ...number[]][];
    background: boolean;
};
export declare const controller: (config: FieldControllerConfig<{
    relationships: Relationships;
    documentFeatures: DocumentFeatures;
    componentBlocksPassedOnServer: string[];
}>) => FieldController<Descendant[]> & {
    componentBlocks: Record<string, ComponentBlock>;
    relationships: Relationships;
    documentFeatures: DocumentFeatures;
};
//# sourceMappingURL=views.d.ts.map